env.info("Campaign: started")

--sets
T1FighterSet = SET_CLIENT:New():FilterPrefixes("T1"):FilterStart()
T2FighterSet = SET_CLIENT:New():FilterPrefixes("T2"):FilterStart()
CASSet = SET_CLIENT:New():FilterPrefixes("CAS"):FilterStart()
ADSet = SET_CLIENT:New():FilterPrefixes("AD"):FilterStart()
ShipSet = SET_CLIENT:New():FilterPrefixes("Ship"):FilterStart()

--zones
Zonegroup1 = GROUP:FindByName( "zone1" )
Zonegroup2 = GROUP:FindByName( "zone2" )
Zone1 = ZONE_POLYGON:New( "something1", Zonegroup1 )
Zone2 = ZONE_POLYGON:New( "something2", Zonegroup2 )
ZoneTable1 = {Zone1}
ZoneTable2 = {Zone2}


--Func to run thru the client set and check if any players have taken a slot
 function AliveSet(set) --thanks to CraigOwen for his help on this, he put me on the right path and it's down to him I stuck with it! #CommunityWin :)
   local count = 0
   set:ForEachClient(
   function (setclient)
    if setclient:IsAlive() then
     count=count+1
    end
   end)
   return count
end


--Spawn objects created
--T1 spawns
ENEMY1 = SPAWN:New("T1 1"):InitLimit(1,0):InitCleanUp(120)
ENEMY2 = SPAWN:New("T1 2"):InitLimit(1,0):InitCleanUp(120)
--T2 spawns
ENEMY3 = SPAWN:New("T2 1"):InitLimit(1,0):InitCleanUp(120)
ENEMY4 = SPAWN:New("T2 2"):InitLimit(1,0):InitCleanUp(120)
--CAS Spawns
CASGROUND1 = SPAWN:New("grnd 1"):InitLimit(16,0):InitRandomizeZones(ZoneTable2)
--AD Spawns
ADGROUND1 = SPAWN:New("AD1"):InitLimit(8,0)
--Ship Spawns
SHIP = SPAWN:New("ship1"):InitLimit(3,0):InitRandomizeZones(ZoneTable1)

--Check periodically what slots are active and handle RTB/despawn/spawn as required
SCHEDULER:New( nil,
function() 

--No player fighters
if AliveSet(T1FighterSet) == 0 then

--env.info("Campaign: No fighters T1FighterSet")
GroupPlane1, Index1 = ENEMY1:GetFirstAliveGroup()
  if GroupPlane1 ~= nil and GroupPlane1:InAir() then GroupPlane1:RouteRTB()
   -- MESSAGE:New("Airborne",3,"T1FighterSet 1"):ToAll()
  elseif GroupPlane1 ~= nil then GroupPlane1:Destroy()
   -- MESSAGE:New("Despawning",3,"T1FighterSet 1"):ToAll()
  else --MESSAGE:New("Does not exist",3,"T1FighterSet 1"):ToAll()
  end

GroupPlane2, Index2 = ENEMY2:GetFirstAliveGroup()
  if GroupPlane2 ~= nil and GroupPlane2:InAir() then GroupPlane2:RouteRTB()
   -- MESSAGE:New("Airborne",3,"T1FighterSet 2"):ToAll()
  elseif GroupPlane2 ~= nil then GroupPlane2:Destroy()
   -- MESSAGE:New("Despawning",3,"T1FighterSet 2"):ToAll()
  else -- MESSAGE:New("Does not exist",3,"T1FighterSet 2"):ToAll()
  end
end

--One player fighter
if AliveSet(T1FighterSet) == 1 then

--env.info("Campaign: 1 fighter T1FighterSet")
GroupPlane1, Index1 = ENEMY1:GetFirstAliveGroup()
  if GroupPlane1 == nil then ENEMY1:Spawn()
  end
  
GroupPlane2, Index2 = ENEMY2:GetFirstAliveGroup()
  if GroupPlane2 ~= nil and GroupPlane2:InAir() then GroupPlane2:RouteRTB()
   -- MESSAGE:New("Airborne",3,"T1FighterSet 2"):ToAll()
  elseif GroupPlane2 ~= nil then GroupPlane2:Destroy()
    --MESSAGE:New("Despawning",3,"T1FighterSet 2"):ToAll()
  else --MESSAGE:New("Does not exist",3,"T1FighterSet 2"):ToAll()
  end
end  

if AliveSet(T1FighterSet) > 1 then

--env.info("Campaign: 2 fighter T1FighterSet")
GroupPlane1, Index1 = ENEMY1:GetFirstAliveGroup()
  if GroupPlane1 == nil then ENEMY1:Spawn()
  end

GroupPlane2, Index2 = ENEMY2:GetFirstAliveGroup()
  if GroupPlane2 == nil then ENEMY2:Spawn()
  end
  
end  

--TF2 fighters checking

if AliveSet(T2FighterSet) == 0 then

--env.info("Campaign: No fighters T2FighterSet")
GroupPlane3, Index3 = ENEMY3:GetFirstAliveGroup()
  if GroupPlane3 ~= nil and GroupPlane3:InAir() then GroupPlane3:RouteRTB()
   -- MESSAGE:New("Airborne",3,"T2FighterSet 1"):ToAll()
  elseif GroupPlane3 ~= nil then GroupPlane3:Destroy()
   -- MESSAGE:New("Despawning",3,"T2FighterSet 1"):ToAll()
  else --MESSAGE:New("Does not exist",3,"T2FighterSet 1"):ToAll()
  end

GroupPlane4, Index2 = ENEMY4:GetFirstAliveGroup()
  if GroupPlane4 ~= nil and GroupPlane4:InAir() then GroupPlane4:RouteRTB()
    --MESSAGE:New("Airborne",3,"T2FighterSet 2"):ToAll()
  elseif GroupPlane4 ~= nil then GroupPlane4:Destroy()
   -- MESSAGE:New("Despawning",3,"T2FighterSet 2"):ToAll()
  else-- MESSAGE:New("Does not exist",3,"T2FighterSet 2"):ToAll()
  end
end

--One player fighter TF2
if AliveSet(T2FighterSet) == 1 then

--env.info("Campaign: 1 fighter T2FighterSet")
GroupPlane3, Index3 = ENEMY3:GetFirstAliveGroup()
  if GroupPlane3 == nil then ENEMY3:Spawn()
  end
  
GroupPlane4, Index4 = ENEMY4:GetFirstAliveGroup()
  if GroupPlane4 ~= nil and GroupPlane4:InAir() then GroupPlane4:RouteRTB()
   -- MESSAGE:New("Airborne",3,"T2FighterSet 2"):ToAll()
  elseif GroupPlane4 ~= nil then GroupPlane4:Destroy()
   -- MESSAGE:New("Despawning",3,"T2FighterSet 2"):ToAll()
  else --MESSAGE:New("Does not exist",3,"T2FighterSet 2"):ToAll()
  end
end  

if AliveSet(T2FighterSet) > 1 then

--env.info("Campaign: 2 fighter T2FighterSet")
GroupPlane3, Index3 = ENEMY3:GetFirstAliveGroup()
  if GroupPlane3 == nil then ENEMY3:Spawn()
  end

GroupPlane4, Index4 = ENEMY4:GetFirstAliveGroup()
  if GroupPlane4 == nil then ENEMY4:Spawn()
  end
  
end  

--end of T2 fighters (worse ones)


--CAS set
if AliveSet(CASSet) == 0 then
--env.info("Campaign: No CAS planes in CASSet")
GroupCAS1, IndexCAS1 = CASGROUND1:GetFirstAliveGroup()
    if GroupCAS1 ~= nil then GroupCAS1:Destroy()
    end
end

if AliveSet(CASSet) > 0 and GroupCAS1 == nil then CASGROUND1:Spawn()
 -- env.info("Campaign: CASSet > 0")
else 
  -- env.info("Campaign: CASSet NOT spawning for some reason")--nothing since its there already
end
 --end of cas

--AD set
if AliveSet(ADSet) == 0 then 
--env.info("Campaign: No AD planes in ADSet")
GroupAD1, IndexAD1 = ADGROUND1:GetFirstAliveGroup()
    if GroupAD1 ~= nil then GroupAD1:Destroy()
    end
end

if AliveSet(ADSet) > 0 and GroupAD1 == nil then ADGROUND1:Spawn()
 -- env.info("Campaign: ADSet > 0")
else
 -- env.info("Campaign: ADSet NOT spawning for some reason") --nothing since its there already
end
 --end of AD



if AliveSet(ShipSet) == 0 then
--env.info("Campaign: No Ship planes in ShipSet")
GroupShip1, IndexShip1 = SHIP:GetFirstAliveGroup()
    if GroupShip1 ~= nil then GroupShip1:Destroy()
    end
end

if AliveSet(ShipSet) > 0 and GroupShip1 == nil then SHIP:Spawn()
 -- env.info("Campaign: ShipSet > 0")
else
 -- env.info("Campaign: ShipSet NOT spawning for some reason") --nothing since its there already
end --end of Ship



end, {}, 1, 10)
